//+------------------------------------------------------------------+
//|                                                 Period_Above.mq4 |
//|                               Copyright  2015, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

extern int                Length           = 14;
extern ENUM_MA_METHOD     Method           =  0;
extern ENUM_APPLIED_PRICE Price            =  0;
extern bool               alertsOn         = false;
extern bool               alertsOnCurrent  = true;
extern bool               alertsMessage    = true;
extern bool               alertsSound      = false;
extern bool               alertsNotify     = false;
extern bool               alertsEmail      = false;

double PA[], PA_Dn[], hu[], hd[], trend[];
int init()
{
   IndicatorShortName("Period Above oscillator");
   IndicatorBuffers(5);
   SetIndexBuffer(0,hu);    SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hd);    SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,PA);
   SetIndexBuffer(3,PA_Dn);
   SetIndexBuffer(4,trend);
   return(0);
}
int deinit(){ return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
   
   for (int i=limit; i>=0; i--)
   {
      double Pr0=iMA(NULL, 0, 1, 0, MODE_SMA, Price, i);
      double Pr1=iMA(NULL, 0, 1, 0, MODE_SMA, Price, i+1);
      double MA0=iMA(NULL, 0, Length, 0, Method, Price, i);
      double MA1=iMA(NULL, 0, Length, 0, Method, Price, i+1);
  
      if (Pr0>MA0)
            PA[i]=PA[i+1]+1.;
      else  PA[i]=PA[i+1]-1.;
      if (Pr0>MA0 && Pr1<MA1) PA[i]= 1.;
      if (Pr0<MA0 && Pr1>MA1) PA[i]=-1.;
      if (PA[i]<0.)
            PA_Dn[i]=PA[i];
      else  PA_Dn[i]=0.;
      hu[i]    = EMPTY_VALUE;
      hd[i]    = EMPTY_VALUE;
      trend[i] = trend[i+1];
      if (PA_Dn[i]==0) { hu[i] = 1; trend[i] =  1; }
      if (PA_Dn[i]!=0) { hd[i] = 1; trend[i] = -1; }
   } 
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1)   doAlert(whichBar,"up");
         if (trend[whichBar] ==-1)   doAlert(whichBar,"down");
      }         
   }
}
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," period above trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " period above"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}